﻿char AppName[]    = { "HRS92-02" };                            /* application name */
char AppTitle[]   = { "Merge for HRS92-02" };                  /* caption for window */
char AboutTitle[] = { "HRS92-02" };                            /* name given in about box */
char AboutDate[]  = { "Nov 2003" };                            /* date given in about box */

#include "\\psf\\Home\\Desktop\\GS\\winshell\\Winshell.inc"


typedef struct
{ int caseid;
  int hhid;
  int persid;
  int subhhid[6];
  } TRACKINGDATA;


void dict(int, char (*)[10], int *, int *);
void tracker(TRACKINGDATA *);
int  trackingcomp(const void *, const void *);
void merge(int, char (*)[10], int *, int *, int *, TRACKINGDATA *trackingdata);
void test(void);
int  eval(int, int);
int  evals(int, char *);
void dictinit(int (*)[2], char (*)[12]);
int  dictcomp(const void *, const void *);


/*---------------------------------------------------------------------------
			 MAINPROG
			 creates the panel data set for the 1992-98 HRS
  ---------------------------------------------------------------------------*/

void mainprog()

{ int  nfiles;

  int  length[104];

  static char filenames[104][10] = {
    "w2track" , "health"  , "employer", "househld", "w2cs"    ,
    "w2a"     , "w2b"     , "w2d"     , "w2e"     , "w2fa"    ,
    "w2fb"    , "w2fc"    , "w2j"     , "w2k"     , "w2v"     ,
    "w2c"     , "w2n"     , "w2r"     , "w2s"     , "w2g"     ,
    "w2h"     , "h96pr_r" , "h96cs_r" , "h96a_r"  , "h96b_r"  ,
    "h96c_r"  , "h96pc_r" , "h96d_h"  , "h96e_r"  , "h96f_h"  ,
    "h96g_r"  , "h96h_r"  , "h96j_r"  , "h96j_h"  , "h96m_r"  ,
    "h96n_r"  , "h96n_h"  , "h96r_r"  , "h96t_r"  , "h98pr_r" ,
    "h98cs_h" , "h98cs_r" , "h98a_r"  , "h98b_r"  , "h98c_r"  ,
    "h98pc_r" , "h98d_h"  , "h98d_r"  , "h98e_r"  , "h98f_h"  ,
    "h98g_r"  , "h98h_r"  , "h98j_h"  , "h98j_r"  , "h98m_r"  ,
    "h98n_h"  , "h98n_r"  , "h98r_r"  , "h98t_r"  , "h00pr_r" ,
    "h00cs_h" , "h00cs_r" , "h00a_r"  , "h00b_r"  , "h00c_r"  ,
    "h00pc_r" , "h00d_h"  , "h00d_r"  , "h00e_r"  , "h00f_h"  ,
    "h00g_r"  , "h00h_r"  , "h00j_h"  , "h00j_r"  , "h00m_r"  ,
    "h00n_h"  , "h00n_r"  , "h00r_r"  , "h00t_r"  , "h02pr_h" ,
    "h02pr_r" , "h02a_h"  , "h02a_r"  , "h02b_r"  , "h02c_r"  ,
    "h02d_r"  , "h02e_h"  , "h02f_r"  , "h02g_r"  , "h02h_h"  ,
    "h02j_r"  , "h02k_r"  , "h02l_r"  , "h02m1_r" , "h02m2_r" ,
    "h02n_r"  , "h02p_r"  , "h02q_h"  , "h02r_h"  , "h02s_r"  ,
    "h02t_r"  , "h02v_r"  , "h02w_r"  , "h02y_r"  };

  static int wave[104] = { // WH: update the first wave number should be track file wave, and track file should be put in that wave folder 
     2         ,  1        ,  1        ,  1        ,  2        ,
     2         ,  2        ,  2        ,  2        ,  2        ,
     2         ,  2        ,  2        ,  2        ,  2        ,
     2         ,  2        ,  2        ,  2        ,  2        ,
     2         ,  3        ,  3        ,  3        ,  3        ,
     3         ,  3        ,  3        ,  3        ,  3        ,
     3         ,  3        ,  3        ,  3        ,  3        ,
     3         ,  3        ,  3        ,  3        ,  4        ,
     4         ,  4        ,  4        ,  4        ,  4        ,
     4         ,  4        ,  4        ,  4        ,  4        ,
     4         ,  4        ,  4        ,  4        ,  4        ,
     4         ,  4        ,  4        ,  4        ,  5        ,
     5         ,  5        ,  5        ,  5        ,  5        ,
     5         ,  5        ,  5        ,  5        ,  5        ,
     5         ,  5        ,  5        ,  5        ,  5        ,
     5         ,  5        ,  5        ,  5        ,  6        ,
     6         ,  6        ,  6        ,  6        ,  6        ,
     6         ,  6        ,  6        ,  6        ,  6        ,
     6         ,  6        ,  6        ,  6        ,  6        ,
     6         ,  6        ,  6        ,  6        ,  6        ,
     6         ,  6        ,  6        ,  6        }; 

  static int matchtype[104] = { // WH: info type 1-individual level 2-household level
     1        ,   1       ,   1       ,   2       ,   1       ,
     1        ,   1       ,   2       ,   1       ,   1       ,
     1        ,   1       ,   1       ,   2       ,   2       ,
     1        ,   2       ,   1       ,   1       ,   1       ,
     1        ,   1       ,   1       ,   1       ,   1       ,
     1        ,   1       ,   2       ,   1       ,   2       ,
     1        ,   1       ,   1       ,   2       ,   1       ,
     1        ,   2       ,   1       ,   1       ,   1       ,
     2        ,   1       ,   1       ,   1       ,   1       ,
     1        ,   2       ,   1       ,   1       ,   2       ,
     1        ,   1       ,   2       ,   1       ,   1       ,
     2        ,   1       ,   1       ,   1       ,   1       ,
     2        ,   1       ,   1       ,   1       ,   1       ,
     1        ,   2       ,   1       ,   1       ,   2       ,
     1        ,   1       ,   2       ,   1       ,   1       ,
     2        ,   1       ,   1       ,   1       ,   2       ,
     1        ,   2       ,   1       ,   1       ,   1       ,
     1        ,   2       ,   1       ,   1       ,   2       ,
     1        ,   1       ,   1       ,   1       ,   1       ,
     1        ,   1       ,   2       ,   2       ,   1       ,
     1        ,   1       ,   1       ,   1       };

  static TRACKINGDATA trackingdata[12652]; // WH: update 12652 to obs in latest track file

  nfiles = 104;

  dict(nfiles, filenames, wave, length);
  tracker(trackingdata);
  merge(nfiles, filenames, wave, length, matchtype, trackingdata); 

 // test();

  }


/*---------------------------------------------------------------------------
			 DICT routine
			 creates the master dictionary for the panel data set
  ---------------------------------------------------------------------------*/

void dict(
  int   nfiles,               /* Number of files to be incorporated */
  char  (*filenames)[10],     /* List of file names to be incorporated */
  int   *wave,                /* Wave of survey that file is in */
  int   *length)              /* Length of the records in the file */

{ int filestart, fileno, flength, linelength;
  int fileloc, loc, len, mergedloc;
  int oldfileloc, oldlen;

  char varname[10], rootname[75], filename[75];
  char str1[120], str2[120], str3[120];
  char inrecord[120], outrecord[120];

  char *quoteptr1, *quoteptr2;

  FILE *datafile, *dictfile, *outfile;
  int  datahandle;


  wnprintf("\nCreating master dictionary");

  outfile = fopen("\\psf\\Home\\Desktop\\GS\\hrs92-02.dic", "wt");

  filestart = 0;

  for (fileno = 0; fileno < nfiles; fileno++)
  { switch(wave[fileno])
    {  case 1:  strcpy(rootname, "\\psf\\Home\\Desktop\\GS\\HRS\\wave1");  break;
       case 2:  strcpy(rootname, "\\psf\\Home\\Desktop\\GS\\HRS\\wave2");  break;
	   case 3:  strcpy(rootname, "\\psf\\Home\\Desktop\\GS\\HRS\\wave3");  break;
	   case 4:  strcpy(rootname, "\\psf\\Home\\Desktop\\GS\\HRS\\wave4");  break;
	   case 5:  strcpy(rootname, "\\psf\\Home\\Desktop\\GS\\HRS\\wave5");  break;
	   case 6:  strcpy(rootname, "\\psf\\Home\\Desktop\\GS\\HRS\\wave6");   break;
       }

    strcat(rootname, filenames[fileno]);
    strcpy(filename, rootname);

//    if (wave[fileno] == 1)
//    strcat(filename, ".ldi");
//    else strcat(filename, ".dct");
	strcat(filename, ".dct"); // WH: edit use dct (STATA dictionary file) for wave 1
    dictfile = fopen(filename, "rt");

    if (dictfile == NULL)
    { wnprintf("\nMissing input dictionary file: %s", filename);
      pause();
      exit(0);
      }
	// WH: edit all dictionary files in STATA format are available on HRS website
    //if (wave[fileno] == 1)
    //{ fgets(inrecord, 120, dictfile);

    //  while(fgets(inrecord, 120, dictfile) != NULL)
    //  { sscanf(&inrecord[36], "%5d", &fileloc);
    //    sscanf(&inrecord[44], "%3d", &len);

    //    memset(outrecord, ' ', 120);

    //    mergedloc = filestart + fileloc;

    //    sprintf(&outrecord[ 0], "%1d", wave[fileno]);     /* survey wave */
    //    memcpy(&outrecord[ 2], &inrecord[ 0],  6);        /* variable name */
    //    memcpy(&outrecord[11], &inrecord[ 7], 24);        /* description */
    //    memcpy(&outrecord[52], filenames[fileno], 8);     /* original file */
    //    sprintf(&outrecord[61], "%5d", fileloc);          /* original column */
    //    sprintf(&outrecord[67], "%5d", mergedloc);        /* merged column */
    //    sprintf(&outrecord[73], "%3d", len);              /* length */

    //    outrecord[1] = ' ';

    //    for (loc = 53; loc < 60; loc++)
    //    if (outrecord[loc] == '\0' || outrecord[loc - 1] == ' ')
    //    outrecord[loc] = ' ';

    //    outrecord[66] = ' ';
    //    outrecord[72] = ' ';

    //    fprintf(outfile, "%s\n", outrecord);
    //    }
    //  }
    //else
    { oldfileloc = 0;
      oldlen = 0;

      while(fgets(inrecord, 120, dictfile) != NULL) // WH: info read each line of dictionary file
      { sscanf(inrecord, "%s %s %s", str1, str2, str3); // WH: info get first three strings

        if (memicmp(str1, "_column(", 8) == 0)
        { sscanf(&str1[8], "%d", &fileloc); // WH: info get column # for each variable as its fileloc

          if (memicmp(str2, "byte", 4) == 0
           || memicmp(str2, "int", 3) == 0
           || memicmp(str2, "long", 4) == 0
           || memicmp(str2, "str", 3) == 0
           || memicmp(str2, "float", 5) == 0
           || memicmp(str2, "double", 6) == 0)
          strcpy(varname, str3);
          else strcpy(varname, str2); // WH: info sometimes type is missing, then 2nd string is varname

          for (loc = 1; loc < 8; loc++)
          if (varname[loc - 1] == ' ' || varname[loc] == 0)
          varname[loc] = ' ';

          linelength = strlen(inrecord);

          sscanf((char *)memchr(inrecord, '%', linelength) + 1, "%d", &len); // WH: info after % is lenghth for this variable, which is len

          quoteptr1 = (char *) memchr(inrecord, '"', linelength); // WH: info inside "" is description for this var
          quoteptr2 = (char *) memchr(quoteptr1 + 1, '"', linelength - (quoteptr1 - inrecord));

          if (quoteptr1 > 0 && quoteptr2 > 0)
          memmove(str1, quoteptr1 + 1, quoteptr2 - quoteptr1 - 1);

          for (loc = quoteptr2 - quoteptr1 - 1; loc < 40; loc++)
          str1[loc] = ' ';

          if (fileno == 0) 
          { if (fileloc == 58) // WH: update . only need this change in W2TRACK file, which W1RWGT should starts in column 59, not 58 as in dictionary file
            fileloc = 59;
            }

		  if (fileloc >= oldfileloc + oldlen) // WH: info  make sure fileloc(new location) is last var column location + last var length
          { oldlen = len;
            oldfileloc = fileloc;
            }
          else
          { wnprintf("\nBad variable column start in %s", filename);
            wnprintf("\n  Old loc and len: %5d %2d", oldfileloc, oldlen);
            wnprintf("\n  New loc and len: %5d %2d", fileloc, len);
            pause();
            }

          memset(outrecord, ' ', 120);

          mergedloc = filestart + fileloc; // WH: info mergedloc is cumulated column in merged data file

          sprintf(&outrecord[ 0], "%1d", wave[fileno]);     /* survey wave */
          memcpy(&outrecord[ 2], varname, 8);               /* variable name */
          memcpy(&outrecord[11], str1, 40);                 /* description */
          memcpy(&outrecord[52], filenames[fileno], 8);     /* original file */
          sprintf(&outrecord[61], "%5d", fileloc);          /* original column */
          sprintf(&outrecord[67], "%5d", mergedloc);        /* merged column */
          sprintf(&outrecord[73], "%3d", len);              /* length */

          outrecord[1] = ' ';

          for (loc = 53; loc < 60; loc++)
          if (outrecord[loc] == '\0' || outrecord[loc - 1] == ' ')
          outrecord[loc] = ' ';

          outrecord[66] = ' ';
          outrecord[72] = ' ';

          fprintf(outfile, "%s\n", outrecord);
          }
        }
      }

    length[fileno] = fileloc + len + 1;

    filestart = filestart + length[fileno] - 2; // WH: info filestart is cumulated column for new merged file to start

    fclose(dictfile);

    strcpy(filename, rootname);
    strcat(filename, ".da");

    if (access(filename, 0) == 0)
    { datafile = fopen(filename, "rb");

      if (datafile == NULL)
      { wnprintf("\nMissing data file: %s", filename);
        pause();
        exit(0);
        }

      datahandle = _fileno(datafile);

      flength = filelength(datahandle);
      wnprintf("\nfile %3d  %8s  reclen %4d  filelen %8d  recs %5d",
        fileno, filenames[fileno], length[fileno], flength, flength / length[fileno]);

      if (flength % length[fileno] != 0) // WH: info error if obs(file length / total columns in data file) not integer
      { wnprintf("\nDictionary length does not agree with file length");
        wnprintf("\nDictionary file name: %s   File length %d", filenames[fileno],
         flength);
        pause();
        exit(0);
        }

      fclose(datafile);
      }
    }

  fclose(outfile);

  }


/*---------------------------------------------------------------------------
			 TRACKER routine
			 creates the tracking information for the merge
  ---------------------------------------------------------------------------*/

void tracker(
  TRACKINGDATA *trackingdata)   /* tracking data structure */

{ int obs, recno, pers;
  int hhid, persid;
  int caseid, subhhid;
  int firstinterview;

  char (*resp)[5][2];

  void *respbuffer, *inbuffer;
  char *inrecord;

  FILE *infile;
  int handle;

  wnprintf("\nCreating tracking data");

  infile = fopen("\\psf\\Home\\Desktop\\GS\\HRS\\wave2\\w2track.da", "rb"); // WH: update to track file location

  if (infile == NULL)
  { wnprintf("\nTracking file missing");
    pause();
    exit(0);
    }

  handle = fileno(infile);

  respbuffer = malloc(1000000);
  resp = (char (*)[5][2]) respbuffer;


  inbuffer = malloc(1577040);

  if (inbuffer == NULL || respbuffer == NULL)
  { wnprintf("\nBuffer allocation failed in routine tracker");
    pause();
    exit(0);
    }

  read(handle, inbuffer, 1577040);

  fclose(infile);

  recno = 0;

  for (obs = 0; obs < 13142; obs++)
  { inrecord = &((char *) inbuffer)[120 * obs];

    sscanf(&inrecord[8], "%2d", &firstinterview);

    if (firstinterview == 1)       /* interviewed in 1992 */
    { sscanf(&inrecord[ 27], "%5d", &caseid);
      sscanf(&inrecord[ 10], "%5d", &hhid);
      sscanf(&inrecord[ 23], "%2d", &persid);
      sscanf(&inrecord[110], "%2d", &subhhid);

      trackingdata[recno].caseid     = caseid;
      trackingdata[recno].hhid       = hhid;
      trackingdata[recno].persid     = persid;
      trackingdata[recno].subhhid[0] = 0;
      trackingdata[recno].subhhid[1] = subhhid;

      recno = recno + 1;

      if (obs % 25 == 0)
      checkMessages();
      }
    }

  free(inbuffer);

  qsort((void *) trackingdata, recno, sizeof(TRACKINGDATA), trackingcomp);

  wnprintf("\nFinished with wave 2 tracking info");

  infile = fopen("c:\\data\\h96cs_r.da", "rb");

  if (infile == NULL)
  { wnprintf("\nWave 3 cover screen file missing");
    pause();
    exit(0);
    }

  handle = fileno(infile);

  inbuffer = malloc(1798096);

  if (inbuffer == NULL)
  { wnprintf("\nBuffer allocation failed for file wave 3 cover screen");
    pause();
    exit(0);
    }

  read(handle, inbuffer, 1798096);

  fclose(infile);

  memset(resp, -1, 1000000);

  for (obs = 0; obs < 10964; obs++)
  { inrecord = &((char *) inbuffer)[164 * obs];

    sscanf(&inrecord[ 0], "%6d", &hhid);           /* household id */
    sscanf(&inrecord[ 6], "%3d", &persid);         /* person id */
    sscanf(&inrecord[ 9], "%1d", &subhhid);        /* subhousehold id */

    if (0 < hhid && hhid < 100000)
    { for (pers = 0; pers < 5; pers++)
      if (resp[hhid][pers][0] == -1)
      break;

      if (pers < 5)
      { resp[hhid][pers][0] = (char) persid;
        resp[hhid][pers][1] = (char) subhhid;
        }
      else
      { wnprintf("\nToo many persons for hhid %d", hhid);
        pause();
        exit(0);
        }
      }

    if (obs % 25 == 0)
    checkMessages();
    }

  for(recno = 0; recno < 12652; recno++)
  { hhid = trackingdata[recno].hhid;
    persid = trackingdata[recno].persid;

    for (pers = 0; pers < 5; pers++)
    { if (resp[hhid][pers][0] == persid)
      trackingdata[recno].subhhid[2] = resp[hhid][pers][1];
      }
    }

  free(inbuffer);

  wnprintf("\nFinished with wave 3 tracking info");

  infile = fopen("c:\\data\\h98cs_r.da", "rb");

  if (infile == NULL)
  { wnprintf("\nWave 4 cover screen file missing");
    pause();
    exit(0);
    }

  handle = fileno(infile);

  inbuffer = malloc(3293136);

  if (inbuffer == NULL)
  { wnprintf("\nBuffer allocation failed for file wave 4 cover screen");
    pause();
    exit(0);
    }

  read(handle, inbuffer, 3293136);

  fclose(infile);

  memset(resp, -1, 1000000);

  for (obs = 0; obs < 21384; obs++)
  { inrecord = &((char *) inbuffer)[154 * obs];

    sscanf(&inrecord[0], "%6d", &hhid);           /* household id */
    sscanf(&inrecord[6], "%3d", &persid);         /* person id */
    sscanf(&inrecord[9], "%1d", &subhhid);        /* subhousehold id */

    if (0 < hhid && hhid < 100000)
    { for (pers = 0; pers < 5; pers++)
      if (resp[hhid][pers][0] == -1)
      break;

      if (pers < 5)
      { resp[hhid][pers][0] = (char) persid;
        resp[hhid][pers][1] = (char) subhhid;
        }
      else
      { wnprintf("\nToo many persons for hhid %d", hhid);
        pause();
        exit(0);
        }
      }

    if (obs % 25 == 0)
    checkMessages();
    }

  for(recno = 0; recno < 12652; recno++)
  { hhid = trackingdata[recno].hhid;
    persid = trackingdata[recno].persid;

    for (pers = 0; pers < 5; pers++)
    { if (resp[hhid][pers][0] == persid)
      trackingdata[recno].subhhid[3] = resp[hhid][pers][1];
      }
    }

  free(inbuffer);

  wnprintf("\nFinished with wave 4 tracking info");

  infile = fopen("c:\\data\\h00cs_r.da", "rb");

  if (infile == NULL)
  { wnprintf("\nWave 5 cover screen file missing");
    pause();
    exit(0);
    }

  handle = fileno(infile);

  inbuffer = malloc(3309020);

  if (inbuffer == NULL)
  { wnprintf("\nBuffer allocation failed for file wave 5 cover screen");
    pause();
    exit(0);
    }

  read(handle, inbuffer, 3309020);

  fclose(infile);

  memset(resp, -1, 1000000);

  for (obs = 0; obs < 19580; obs++)
  { inrecord = &((char *) inbuffer)[169 * obs];

    sscanf(&inrecord[0], "%6d", &hhid);           /* household id */
    sscanf(&inrecord[6], "%3d", &persid);         /* person id */
    sscanf(&inrecord[9], "%1d", &subhhid);        /* subhousehold id */

    if (0 < hhid && hhid < 100000)
    { for (pers = 0; pers < 5; pers++)
      if (resp[hhid][pers][0] == -1)
      break;

      if (pers < 5)
      { resp[hhid][pers][0] = (char) persid;
        resp[hhid][pers][1] = (char) subhhid;
        }
      else
      { wnprintf("\nToo many persons for hhid %d", hhid);
        pause();
        exit(0);
        }
      }

    if (obs % 25 == 0)
    checkMessages();
    }

  for(recno = 0; recno < 12652; recno++)
  { hhid = trackingdata[recno].hhid;
    persid = trackingdata[recno].persid;

    for (pers = 0; pers < 5; pers++)
    { if (resp[hhid][pers][0] == persid)
      trackingdata[recno].subhhid[4] = resp[hhid][pers][1];
      }
    }

  free(inbuffer);

  wnprintf("\nFinished with wave 5 tracking info");

  infile = fopen("c:\\data\\h02a_r.da", "rb");

  if (infile == NULL)
  { wnprintf("\nWave 6 cover screen file missing");
    pause();
    exit(0);
    }

  handle = fileno(infile);

  inbuffer = malloc(1308024);

  if (inbuffer == NULL)
  { wnprintf("\nBuffer allocation failed for file wave 6 cover screen");
    pause();
    exit(0);
    }

  read(handle, inbuffer, 1308024);

  fclose(infile);

  memset(resp, -1, 1000000);

  for (obs = 0; obs < 18167; obs++)
  { inrecord = &((char *) inbuffer)[72 * obs];

    sscanf(&inrecord[ 0], "%6d", &hhid);           /* household id */
    sscanf(&inrecord[ 6], "%3d", &persid);         /* person id */
    sscanf(&inrecord[10], "%1d", &subhhid);        /* subhousehold id */

    if (0 < hhid && hhid < 100000)
    { for (pers = 0; pers < 5; pers++)
      if (resp[hhid][pers][0] == -1)
      break;

      if (pers < 5)
      { resp[hhid][pers][0] = (char) persid;
        resp[hhid][pers][1] = (char) subhhid;
        }
      else
      { wnprintf("\nToo many persons for hhid %d", hhid);
        pause();
        exit(0);
        }
      }
    checkMessages();
    }

  for(recno = 0; recno < 12652; recno++)
  { hhid = trackingdata[recno].hhid;
    persid = trackingdata[recno].persid;

    for (pers = 0; pers < 5; pers++)
    { if (resp[hhid][pers][0] == persid)
      trackingdata[recno].subhhid[5] = resp[hhid][pers][1];
      }
    }

  free(inbuffer);

  free(respbuffer);

  }


/*---------------------------------------------------------------------------
			 TRACKING COMP routine
			 compare routine for qsort in the tracking routine
  ---------------------------------------------------------------------------*/

int trackingcomp(
  const void *elem1,
  const void *elem2)

{ TRACKINGDATA *tracker1, *tracker2;

  tracker1 = (TRACKINGDATA *) elem1;
  tracker2 = (TRACKINGDATA *) elem2;

  if (tracker1->hhid < tracker2->hhid)
  return(-1);

  if (tracker1->hhid > tracker2->hhid)
  return(1);

  if (tracker1->caseid < tracker2->caseid)
  return(-1);
  else return(1);

  }


/*---------------------------------------------------------------------------
			 MERGE routine
			 Merges the individual files into a panel file
  ---------------------------------------------------------------------------*/

void merge(
  int  nfiles,                 /* Number of files to be incorporated */
  char (*filenames)[10],       /* List of file names to be incorporated */
  int  *wavevec,               /* Wave of survey that file is in */
  int  *length,                /* Length of the records in the file */
  int  *matchtype,             /* Pattern of matching variables */
  TRACKINGDATA *trackingdata)  /* tracking data structure */

{ int   pers, obs, npers, nobs;
  int   wave, type;
  int   recno, rectot;
  int   bufferloc, fileloc;
  int   flength, fileno, mlength, reclength;
  int   hhid, persid, caseid, subhhid;

  char  filename[60];

  typedef struct
  { int npers;
    struct
    { char  persid;
      char  subhhid;
      short recno;
      } persno[5];
    } RECLOCS;

  RECLOCS *reclocs;

  void *inbuffer, *mergebuffer, *reclocbuffer;
  char *inrec;

  FILE *infile, *mergefile;
  int  inhandle, mhandle;

  mlength = 0;

  for (fileno = 0; fileno < nfiles; fileno++)
  mlength = mlength + (length[fileno] - 2);

  wnprintf("\n\nLength of merged file records is %d", mlength);
  wnprintf("\nStarting merge");

  mergebuffer = malloc(12652 * mlength);
  reclocbuffer = malloc(100000 * sizeof(RECLOCS));

  if (mergebuffer == NULL || reclocbuffer == NULL)
  { wnprintf("\nMerge buffer allocation failed in merge routine");
    pause();
    exit(0);
    }

  if (access("c:\\data\\hrs92-02.dat", 0) < 0)
  memset(mergebuffer, 0, 12652 * mlength);
  else
  { mergefile = fopen("c:\\data\\hrs92-02.dat", "rb");
    mhandle = _fileno(mergefile);
    read(mhandle, mergebuffer, 12652 * mlength);
    fclose(mergefile);
    }
  
  reclocs = (RECLOCS *) reclocbuffer;

  fileloc = 0;

  for (fileno = 0; fileno < nfiles; fileno++)
  { wave = wavevec[fileno];
    type = matchtype[fileno];

    reclength = length[fileno];

    if (0 <= fileno && fileno < nfiles)      /* to add only selected files */
    { switch(wave)
      { case 1:  strcpy(filename, "c:\\data\\");  break;
        case 2:  strcpy(filename, "c:\\data\\");  break;
        case 3:  strcpy(filename, "c:\\data\\");  break;
        case 4:  strcpy(filename, "c:\\data\\");  break;
        case 5:  strcpy(filename, "c:\\data\\");  break;
        case 6:  strcpy(filename, "c:\\data\\");   break;
        }

      strcat(filename, filenames[fileno]);
      strcat(filename, ".da");

      wnprintf("\n  Adding file %s", filename);

      infile = fopen(filename, "rb");

      if (infile == NULL)
      { wnprintf("\nMissing data file: %s", filename);
        pause();
        exit(0);
        }

      inhandle = _fileno(infile);

      flength = filelength(inhandle);

      inbuffer = malloc(flength);

      if (inbuffer == NULL)
      { wnprintf("\nBuffer allocation failed for file %s", filename);
        pause();
        exit(0);
        }

      read(inhandle, inbuffer, flength);

      fclose(infile);

      nobs = flength / reclength;

      memset(reclocs, 0, sizeof(RECLOCS[100000]));

      for (obs = 0; obs < nobs; obs++)
      { if (obs % 25 == 0)
        checkMessages();
      
        inrec = &((char *) inbuffer)[reclength * obs];

        switch(wave)
        { case 1:                     sscanf(&inrec[0], "%5d", &caseid);
                                      sscanf(&inrec[5], "%5d", &hhid);
                                      subhhid = 0;

                                      if (caseid < 20000) persid = 10;
                                      else                persid = 20;         break;


          case 2:  if (fileno == 0) { sscanf(&inrec[ 10], "%5d", &hhid);
                                      sscanf(&inrec[ 23], "%2d", &persid);
                                      sscanf(&inrec[110], "%2d", &subhhid); }

                   else if (fileno == 6 || fileno == 17 || fileno == 18)   /* B, R, & S */
                                    { sscanf(&inrec[0], "%5d", &hhid);
                                      sscanf(&inrec[5], "%2d", &persid);
                                      sscanf(&inrec[7], "%1d", &subhhid);  }

                   else             { sscanf(&inrec[0], "%5d", &hhid);
                                      sscanf(&inrec[6], "%2d", &persid);
                                      sscanf(&inrec[5], "%1d", &subhhid);  }   break;

          case 3:
          case 4:
          case 5:  if (type == 2)   { sscanf(&inrec[0], "%6d", &hhid);
                                      sscanf(&inrec[6], "%1d", &subhhid);
                                      persid = -1;                         }

                   else             { sscanf(&inrec[0], "%6d", &hhid);
                                      sscanf(&inrec[6], "%3d", &persid);
                                      sscanf(&inrec[9], "%1d", &subhhid);  }   break;

          case 6:  if (type == 2)   { sscanf(&inrec[0], "%6d", &hhid);
                                      sscanf(&inrec[7], "%1d", &subhhid);
                                      persid = -1;                         }

                   else
                   { if (fileno != 102)
                                    { sscanf(&inrec[ 0], "%6d", &hhid);
                                      sscanf(&inrec[ 6], "%3d", &persid);
                                      sscanf(&inrec[10], "%1d", &subhhid);  }

                     else           { sscanf(&inrec[ 3], "%6d", &hhid);
                                      sscanf(&inrec[ 9], "%3d", &persid);
                                      sscanf(&inrec[13], "%1d", &subhhid);  }
                     }                                                         break;

          }

        if (0 < hhid && hhid < 100000)
        { npers = reclocs[hhid].npers;

          if (npers < 5)
          { reclocs[hhid].persno[npers].persid  = (char)  persid;
            reclocs[hhid].persno[npers].subhhid = (char)  subhhid;
            reclocs[hhid].persno[npers].recno   = (short) obs;
            reclocs[hhid].npers = reclocs[hhid].npers + 1;
            }
          else
          { wnprintf("\nToo many persons for hhid %d in file %s", hhid, filename);
            pause();
            exit(0);
            }
          }
        }

      rectot = 0;

      for (obs = 0; obs < 12652; obs++)
      { recno = -1;

        hhid    = trackingdata[obs].hhid;
        subhhid = trackingdata[obs].subhhid[wave - 1];
        persid  = trackingdata[obs].persid;

        if (type == 1)
        { if (wave == 1)
          { caseid = trackingdata[obs].caseid;

            if (caseid < 20000)
            persid = 10;
            else persid = 20;
            }

          for (pers = 0; pers < reclocs[hhid].npers; pers++)
          if (reclocs[hhid].persno[pers].persid == persid)
          { recno = reclocs[hhid].persno[pers].recno;
            rectot = rectot + 1;
            }
          }
        else
        { for (pers = 0; pers < reclocs[hhid].npers; pers++)
          if (reclocs[hhid].persno[pers].subhhid == subhhid)
          { recno = reclocs[hhid].persno[pers].recno;
            rectot = rectot + 1;
            }
          }

        if (recno >= 0)
        memcpy(&((char *) mergebuffer)[obs * mlength + fileloc],
         &((char *) inbuffer)[reclength * recno], length[fileno] - 2);

        checkMessages();
        }

      free(inbuffer);

      wnprintf("   records added: %d", rectot);

      if (fileno % 10 == 9)
      { mergefile = fopen("c:\\data\\hrs92-02.dat", "wb");
        mhandle = _fileno(mergefile);
        write(mhandle, mergebuffer, 12652 * mlength);
        fclose(mergefile);
        }
      }

    fileloc = fileloc + (length[fileno] - 2);
    }

  mergefile = fopen("c:\\data\\hrs92-02.dat", "wb");
  mhandle = _fileno(mergefile);
  write(mhandle, mergebuffer, 12652 * mlength);
  fclose(mergefile);

  free(reclocbuffer);
  free(mergebuffer);
  pause();

  }


/*---------------------------------------------------------------------------
			 TEST routine
			 tests the eval routine
  ---------------------------------------------------------------------------*/

char rec[57478];

void test()

{ int   obs;
  int   hhid, codeid, matchid;
  int   w1birthyear, w2birthyear, w3birthyear, w6birthyear;
  int   w1gender, w2gender, w3gender, w4gender, w5gender, w6gender;
  int   w3famresp, w3finresp;
  int   w4famresp, w4finresp, w4lasttype;
  int   w5famresp, w5finresp, w5lasttype;
  int   w6famresp, w6finresp, w6lasttype;

  FILE *infile;
  int handle;

  infile = fopen("c:\\data\\hrs92-02.dat", "rb");
  handle = fileno(infile);

  for (obs = 0; obs < 12652; obs++)
  { read(handle, rec, 57478);

    hhid = evals(2, "HHID");
    codeid = eval(1, 1);
    matchid = eval(1, 3);
    w1birthyear = eval(1, 44);
    w1gender = eval(1, 47);
    w2birthyear = eval(2, 53);
    w2gender = eval(2, 50);
    w3birthyear = eval(3, 373);
    w3gender = eval(3, 374);
    w3famresp = eval(3, 376);
    w3finresp = eval(3, 377);
    w4gender = eval(4, 469);
    w4famresp = evals(4, "FFAMR");
    w4finresp = evals(4, "FFINR");
    w4lasttype = eval(4, 471);
    w5gender = eval(5, 757);
    w5famresp = evals(5, "GFAMR");
    w5finresp = evals(5, "GFINR");
    w5lasttype = eval(5, 492);
    w6birthyear = evals(6, "HX067_R");
    w6gender = evals(6, "HX060_R");
    w6famresp = evals(6, "HFAMR");
    w6finresp = evals(6, "HFINR");
    w6lasttype = evals(6, "HZ007");

    if (w1birthyear < 0) w1birthyear = 0;
    if (w2birthyear < 0) w2birthyear = 0;
    if (w3birthyear < 0) w3birthyear = 0;
    if (w6birthyear < 0) w6birthyear = 0;
    if (w1gender < 0) w1gender = 0;
    if (w2gender < 0) w2gender = 0;
    if (w3gender < 0) w3gender = 0;
    if (w4gender < 0) w4gender = 0;
    if (w5gender < 0) w5gender = 0;
    if (w6gender < 0) w6gender = 0;
    if (w3famresp < 0) w3famresp = 0;
    if (w3finresp < 0) w3finresp = 0;
    if (w4famresp < 0) w4famresp = 0;
    if (w4finresp < 0) w4finresp = 0;
    if (w4lasttype < 0) w4lasttype = 0;
    if (w5famresp < 0) w5famresp = 0;
    if (w5finresp < 0) w5finresp = 0;
    if (w5lasttype < 0) w5lasttype = 0;
    if (w6famresp < 0) w6famresp = 0;
    if (w6finresp < 0) w6finresp = 0;
    if (w6lasttype < 0) w6lasttype = 0;

    wnprintf("\n%5d %5d %5d %5d", obs, hhid, codeid, matchid);
    wnprintf("  %4d %4d %4d %4d", w1birthyear, w2birthyear, w3birthyear, w6birthyear);
    wnprintf("  %1d %1d %1d %1d %1d %1d", w1gender, w2gender, w3gender, w4gender, w5gender, w6gender);
    wnprintf("  %1d %1d  %1d", w3famresp, w3finresp, w4lasttype);
    wnprintf("  %1d %1d  %1d", w4famresp, w4finresp, w5lasttype);
    wnprintf("  %1d %1d  %1d", w5famresp, w5finresp, w6lasttype);
    wnprintf("  %1d %1d", w6famresp, w6finresp);

    if (w1birthyear != w2birthyear && w2birthyear != 0) pause();
    if (w1birthyear != w3birthyear && w3birthyear != 0) pause();
    if (w1birthyear != w6birthyear && w6birthyear != 0) pause();

    if (w1gender != w2gender && w2gender != 0) pause();
    if (w1gender != w3gender && w3gender != 0) pause();
    if (w1gender != w4gender && w4gender != 0) pause();
    if (w1gender != w5gender && w5gender != 0) pause();
    if (w1gender != w6gender && w6gender != 0) pause();

    /* if (w3famresp == 1 && w3finresp == 2 && w4lasttype != 3 && w4lasttype != 0) pause();
    if (w3famresp == 1 && w3finresp == 3 && w4lasttype != 2 && w4lasttype != 0) pause();
    if (w3famresp == 2 && w3finresp == 2 && w4lasttype != 1 && w4lasttype != 0) pause();
    if (w3famresp == 2 && w3finresp == 3 && w4lasttype != 4 && w4lasttype != 0) pause();

    if (w4resptype != w5lasttype && w4resptype > 0 && w5lasttype > 0) pause(); */

    if (hhid < 0) pause();

    checkMessages();
    }

  fclose(infile);

  }


/*---------------------------------------------------------------------------
			 EVAL routine
			 gets a numeric-named variable from the HRS records
  ---------------------------------------------------------------------------*/

int eval(
  int  wave,
  int  varno)

{ char varname[9];

  switch(wave)
  { case  1:  varname[0] = 'V';      break;
    case  2:  varname[0] = 'W';      break;
    case  3:  varname[0] = 'E';      break;
    case  4:  varname[0] = 'F';      break;
    case  5:  varname[0] = 'G';      break;
    case  6:  varname[0] = 'H';      break;
    }

  sprintf(&varname[1], "%d", varno);

  return(evals(wave, varname));

  }


/*---------------------------------------------------------------------------
			 EVALS routine
			 gets a character-named variable from the HRS records
  ---------------------------------------------------------------------------*/

typedef struct
{ int  wave;
  char varname[8];
  int  loc;
  int  len;
  } VARDEF;


int evals(
  int  wave,
  char *vararg)

{ int loc, len, value;
  int varno, varmin, varmax, newvar;

  char var[8];

  static int varlims[6][2];
  static char varlocs[25519][12];

  static int init = 1;
  static char blanks[12] = "           ";

  if (init == 1)
  { dictinit(varlims, varlocs);
	 init = 0;
	 }

  memcpy(var, vararg, 8);

  for (loc = 1; loc < 8; loc++)
  if (var[loc - 1] == ' ' || var[loc] == '\0')
  var[loc] = ' ';

  varmin = varlims[wave - 1][0];
  varmax = varlims[wave - 1][1];

  while (varmin + 1 < varmax)
  { newvar = (varmin + varmax) / 2;

    if (strncmp(var, varlocs[newvar], 8) > 0)
    varmin = newvar;
    else varmax = newvar;
    }

  if (varmin == varlims[wave][0])
  { if (strncmp(var, varlocs[varmin], 8) == 0)
    varno = varmin;
    else varno = varmax;
    }
  else varno = varmax;

  if (strncmp(var, varlocs[varno], 8) != 0)
  { wnprintf("\nVariable %8.8s not in dictionary", var);
	 pause();
	 exit(0);
    }

  loc = * (unsigned short *) &varlocs[varno][ 8];
  len = * (unsigned short *) &varlocs[varno][10];

  if (rec[loc] > 0)
  { if (memcmp(&rec[loc], blanks, len) != 0)
    switch(len)
    { case  1:  sscanf(&rec[loc],  "%1d", &value);     break;
	   case  2:  sscanf(&rec[loc],  "%2d", &value);     break;
	   case  3:  sscanf(&rec[loc],  "%3d", &value);     break;
	   case  4:  sscanf(&rec[loc],  "%4d", &value);     break;
	   case  5:  sscanf(&rec[loc],  "%5d", &value);     break;
	   case  6:  sscanf(&rec[loc],  "%6d", &value);     break;
	   case  7:  sscanf(&rec[loc],  "%7d", &value);     break;
	   case  8:  sscanf(&rec[loc],  "%8d", &value);     break;
	   case  9:  sscanf(&rec[loc],  "%9d", &value);     break;
	   case 10:  sscanf(&rec[loc], "%10d", &value);     break;
	   case 11:  sscanf(&rec[loc], "%11d", &value);     break;
     default:  error("eval length too long");         break;
      }
    else return(0);
	 }
  else return(-9999);

  return(value);

  }


/*---------------------------------------------------------------------------
			 DICT INIT routine
			 gets the HRS dictionaries to locate the variables
  ---------------------------------------------------------------------------*/

void dictinit(
  int  (*varlims)[2],
  char (*varlocs)[12])

{ int  wave, loc, len, var, varno;
  char linestring[120];

  void *varbuffer;
  VARDEF *vardefs;

  FILE *dictfile;

  varbuffer = malloc(25519 * sizeof(VARDEF));
  vardefs = (VARDEF *) varbuffer;

  memset(varlocs, 0, 25519 * 12);
  memset(vardefs, 0, 25519 * sizeof(VARDEF));

  dictfile = fopen("c:\\data\\hrs92-02.dic", "rt");

  if (dictfile == NULL)
  { wnprintf("\nMissing dictionary file");
    pause();
    exit(0);
    }

  var = 0;

  while(fgets(linestring, 120, dictfile) != NULL)
  { sscanf(&linestring[ 0], "%1d", &wave);
    sscanf(&linestring[67], "%5d", &loc);
	 sscanf(&linestring[73], "%3d", &len);

    vardefs[var].wave = wave;
    vardefs[var].loc  = loc - 1;
    vardefs[var].len  = len;

    strncpy(vardefs[var].varname, &linestring[2], 8);

    var = var + 1;
	 }

  fclose(dictfile);

  qsort(vardefs, var, sizeof(VARDEF), dictcomp);

  memset(varlims, 0, 10 * sizeof(int));

  for (varno = 0; varno < var; varno++)
  { strncpy(varlocs[varno], vardefs[varno].varname, 8);

    * (unsigned short *) &varlocs[varno][ 8] = (unsigned short) (vardefs[varno].loc);
	 * (unsigned short *) &varlocs[varno][10] = (unsigned short) (vardefs[varno].len);

    for (wave = 0; wave < 6; wave++)
    { if (vardefs[varno].wave - 1 < wave)
      varlims[wave][0] = varno + 1;

      if (vardefs[varno].wave - 1 <= wave)
      varlims[wave][1] = varno;
      }
    }

  }


/*---------------------------------------------------------------------------
			 DICT COMP routine
			 compare routine for qsort in the dictinit routine
  ---------------------------------------------------------------------------*/

int dictcomp(
  const void *elem1,
  const void *elem2)

{ if ((* (VARDEF *) elem1).wave < (* (VARDEF *) elem2).wave)
  return(-1);
  else if ((* (VARDEF *) elem1).wave > (* (VARDEF *) elem2).wave)
  return(1);

  if (strncmp((* (VARDEF *) elem1).varname, (* (VARDEF *) elem2).varname, 8) < 0)
  return(-1);
  if (strncmp((* (VARDEF *) elem1).varname, (* (VARDEF *) elem2).varname, 8) > 0)
  return(1);

  if ((* (VARDEF *) elem1).loc < (* (VARDEF *) elem2).loc)
  return(-1);
  else return(1);

  }

